input {
  beats {
    port => 5044
  }
}
filter {
  if([agent][type] == "filebeat" and [service][type] == "nginx"){
    if [fileset][name] == "access" {
      grok {
        match => { "message" => ["%{IPORHOST:[source][ip]} - %{DATA:[user][name]} \[%{HTTPDATE:[nginx][access][time]}\] \"%{WORD:[http][request][method]} %{DATA:[url][original]} HTTP/%{NUMBER:[http][version]}\" %{NUMBER:[http][response][status_code]} %{NUMBER:[http][response][body][bytes]} \"%{DATA:[http][request][referrer]}\" \"%{DATA:[user_agent][original]}\""] }
        remove_field => "message"
      }
      if([url][original] =~ /(.*\.(js|css|svg|png|gif|jpg|jpeg|tif|json|txt|ico))|(\/server-status)/){
        drop{ }
      }
      mutate {
        rename => { "@timestamp" => "[event][created]" }
      }
      date {
        match => [ "[nginx][access][time]", "dd/MMM/YYYY:H:m:s Z" ]
        remove_field => "[nginx][access][time]"
      }
      useragent {
        source => "[user_agent][original]"
        target => "user_agent"
      }
      mutate {
        add_field => { "[event][category]" => "web" }
      }
      mutate {
        add_field => { "[event][type]" => "access" }
      }
      geoip {
        source => "[source][ip]"
        target => "[source][geo]"
        database => "/usr/share/filebeat/GeoLite2-City.mmdb"
      }
    } else if [fileset][name] == "error" {
      grok {
        match => { "message" => ["%{DATA:[nginx][error][time]} \[%{DATA:[log][level]}\] %{NUMBER:[process][pid]}#%{NUMBER:[process][thread][id]}: (\*%{NUMBER:[nginx][error][connection_id]} )?%{GREEDYDATA:[nginx][error][message]}"] }
      }
      mutate {
        rename => { "[nginx][error][message]" => "message" }
      }
      mutate {
        rename => { "@timestamp" => "[event][created]" }
      }
      date {
        match => [ "[nginx][error][time]", "YYYY/MM/dd H:m:s" ]
        remove_field => "[nginx][error][time]"
      }
      mutate {
        add_field => { "[event][category]" => "web" }
      }
      mutate {
        add_field => { "[event][type]" => "error" }
      }
    }
  }
}
output {
  if([agent][type] == "filebeat") {
    amazon_es {
      hosts => ["{{ elasticsearch_host }}"]
      region => "{{ region }}"
      aws_access_key_id => '{{ access_key }}'
      aws_secret_access_key => '{{ secret_key }}'
      index => "%{[@metadata][beat]}-%{[@metadata][version]}-%{+yyyy.MM.dd}"
      manage_template => true
      template => "/usr/share/filebeat/filebeat.template.json"
      template_name => "filebeat-7.9.1"
      template_overwrite => true
    }
  } else if([agent][type] == "metricbeat") {
    amazon_es {
      hosts => ["{{ elasticsearch_host }}"]
      region => "{{ region }}"
      aws_access_key_id => '{{ access_key }}'
      aws_secret_access_key => '{{ secret_key }}'
      index => "%{[@metadata][beat]}-%{[@metadata][version]}-%{+yyyy.MM.dd}"
    }
  }
}

